// $Id: jabylon.java,v 1.10 2001/12/30 07:43:01 satan Exp $
/* 
 * Jabylon: English Japanese translator for Java.
 */

import java.awt.*;
import java.io.*;
import java.lang.*;
import java.util.*;
import java.awt.event.*;
import java.awt.datatransfer.*;

public class jabylon extends Frame {
    static final String s_close = "Close";

    public jabylon(String word, String dic_file, String encoding) throws IOException {
	super("Jabylon: " + word);

	final int  bufsz = 8192;

	// File f = new File(dic_file);
	// FileInputStream in = new FileInputStream(f);
	sBufferedReader sbr = new sBufferedReader(new InputStreamReader(new FileInputStream(new File(dic_file))));
	String s = null;
	try {
	    s = sbr.stringMatch(word, word.length(), encoding);
	    if (s == null) {
		s = word + " : not found.";
	    }
	} catch (IOException e) {
	    System.out.println(e);
	}

	// If the word is past tense, try searching current tense.
	if (word.endsWith("ed") == true) {
	    int idx = word.length() - 2;
	    String wrd = word;
	    if (idx > 2 && word.charAt(idx - 1) == word.charAt(idx - 2)) {
		idx -= 1;
	    } else if (word.charAt(idx - 1) == 'i') {
		StringBuffer wd = new StringBuffer(word);
		wd.replace(idx - 1, idx, "y");
		wrd = wd.toString();
	    }

	    sbr = new sBufferedReader(new InputStreamReader(new FileInputStream(new File(dic_file))));
	    s = null;
	    try {
		s = sbr.stringMatch(wrd, idx, encoding);
		if (s == null) {
		    s = word + " : not found.";
		}
	    } catch (IOException e) {
		System.out.println(e);
	    }
	}

	// If the word is gerund, try searching original verb.
	if (word.endsWith("ing") == true) {
	    int idx = word.length() - 3;
	    System.out.println("Index = " + idx);
	    if (idx > 2) {
		if (word.charAt(idx - 1) == word.charAt(idx - 2))
		    idx -= 1;
	    }
	    // System.out.println("Index = " + idx);
	    sbr = new sBufferedReader(new InputStreamReader(new FileInputStream(new File(dic_file))));
	    s = null;
	    try {
		s = sbr.stringMatch(word, idx, encoding);
		if (s == null) {
		    s = word + " : not found.";
		}
	    } catch (IOException e) {
		System.out.println(e);
	    }
	}
	
	// System.out.println(wd + ": " + s);

	TextArea txa = new TextArea(s, 24, 80, TextArea.SCROLLBARS_VERTICAL_ONLY);
	txa.setFont(new Font("dialog", Font.PLAIN, 12));
	txa.setBackground(Color.yellow);
	txa.setForeground(Color.red);	
	txa.setEditable(false);
	this.add("Center", txa);

	Button close = new Button(s_close);
	ButtonListener bltn = new ButtonListener();
	close.addActionListener(bltn);
	this.add("South", close);
	this.pack();
	this.show();

	Timer tmr = new Timer();
    }

    class ButtonListener implements ActionListener {
	public void actionPerformed(ActionEvent e) {
	    String s = e.getActionCommand();
	    if (s.compareTo(s_close) == 0) {
		System.exit(0);
	    }
	}
    }

    class sBufferedReader extends BufferedReader {
	public sBufferedReader(InputStreamReader inpstr) {
	    super(inpstr);
	}
	public String stringMatch(String string, int length, String encoding) throws IOException {
	    String ln;
	    while ((ln = this.readLine()) != null) {
		String s = new String(ln.getBytes(encoding));
		// System.out.println(string + " : " + length + " : " + s);
		if (s.regionMatches(true, 0, string, 0, length) == true) {
		    return s;
		}
	    }
	    return null;
	}
    }

    static public void main(String[] args) throws IOException {
	final String dictionary = "/usr/local/lib/ejdic.euc";
	final String encoding = "EUC-JP";
	String word = null;

	Clipboard cb = Toolkit.getDefaultToolkit().getSystemClipboard();
	Transferable cn = cb.getContents(null);
	try {
	    word = new String(cn.getTransferData(DataFlavor.stringFlavor).toString());
	} catch (Throwable e) {
	    System.err.println(e);
	}

	if (word == null) {
	    System.out.println("There found no word in the cut buffer.");
	    System.exit(1);
	}
	// System.out.println("word from cut buffer: [ " + word + " ](" + word.length() + ")");

	try {
	    Frame frame = new jabylon(word, dictionary, encoding);
	}
	catch (IOException e) {
	    System.out.println(e);
	    System.exit(1);
	}
    }
}

// EOF
